/******************************************************************************** 
    Desarrollado por:   Avanxo México
    Autor:              Héctor Figueroa
    Proyecto:           TOYOTA TAM
    Descripción:        Clase que contiene la logica para procesar los registros del archivo de TAM_ClienteServicioPaso
    					y crea los contactos asociados a las cuentas en Accoint 

    Infomación de cambios (versiones)
    ===============================================================================
    No.    Fecha             Autor                       Descripcion
    1.0    29-Julio-2019     Héctor Figueroa             Creación
******************************************************************************* */

public with sharing class TAM_ClienteServicioPaso_tgr_handler extends TriggerHandler {

	private List<TAM_ClienteServicioPaso__c> CteServList;
	private Map<Id,TAM_ClienteServicioPaso__c> mapCtesServ;
    private Map<String,Map<String,RecordType>> recordTypesMap;
	
    public TAM_ClienteServicioPaso_tgr_handler() {
		this.CteServList = Trigger.new;
		this.mapCtesServ = (Map<Id,TAM_ClienteServicioPaso__c>)Trigger.newMap;
        this.recordTypesMap = Constantes.TIPOS_REGISTRO_DEVNAME_ID;     	
	}

	public override void afterInsert(){
		validateRecords(CteServList);
		eliminaRecords(mapCtesServ);
	}

	private void eliminaRecords(Map<Id,TAM_ClienteServicioPaso__c> mapCtesServ){
		System.debug('ENTRO A TAM_ClienteServicioPaso_tgr_handler eliminaRecords...');		
		Set<String> vines = new Set<String>();
		for(TAM_ClienteServicioPaso__c v: mapCtesServ.values()){
			vines.add(v.id);
		}
		if(vines.size()>0){
			List<TAM_ClienteServicioPaso__c> borrar = new List<TAM_ClienteServicioPaso__c>();
			for(TAM_ClienteServicioPaso__c v : [SELECT Id, Name FROM TAM_ClienteServicioPaso__c WHERE ID IN :vines]){
				borrar.add(v);
			}
			System.debug('ENTRO A TAM_ClienteServicioPaso_tgr_handler eliminaRecords borrar: ' + borrar);			
			if(borrar.size()>0){
				//delete borrar;
				List<Database.DeleteResult> lDtbUpsRes = Database.delete(borrar, false);
				//Ve si hubo error
				for (Database.DeleteResult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess())
						System.debug('Error a la hora de eliminar el reg ' + objDtbUpsRes.getErrors()[0].getMessage());	
				}//Fin del for para lDtbUpsRes
			}//Fin si borrar.size()>0
		}
	}

	private void validateRecords(List<TAM_ClienteServicioPaso__c> CteServList){
		String sToyota = 'TOYOTA FINANCIAL SERVICES';
		String sToyotaCompleto = 'TOYOTA FINANCIAL SERVICES MEXICO SA DE CV';
	    String VaRtAccRegPM = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Moral').getRecordTypeId();
    	String VaRtAccRegPF = Schema.SObjectType.Account.getRecordTypeInfosByName().get('Cliente - Persona Fisica').getRecordTypeId();
    	String VaRtContRegPF = Schema.SObjectType.Contact.getRecordTypeInfosByName().get('Contactos-Clientes').getRecordTypeId();
    			
		map<String, String> mapVinOppIdExtCliente = new map<String, String>();
		Set<String> setErroresAccUps = new Set<String>();

		map<String, String> mapVinOppIdExtClienteContacto = new map<String, String>();
		Set<String> setErroresAccContactUps = new Set<String>();

    	map<String, Account> mapClientesUps = new Map<String, Account>();
		Set<String> setIdCtesCreados = new Set<String>();    	
    	map<String, String> mapIdClientesId = new Map<String, String>();
    	
		Set<String> sIdVin = new Set<String>();
		map<String, Opportunity> mapOppUps = new map<String, Opportunity>();
		Set<String> setErroresOppUps = new Set<String>();
		Set<String> setIdOppUps = new Set<String>();		
		map<String, String> mapVinOppIdUps = new map<String, String>();
		
    	map<String, Contact> mapContactosUps = new Map<String, Contact>();
		Set<String> setIdContactCreados = new Set<String>();
		Set<String> setErroresContactosUps = new Set<String>();		    	
    	map<String, Contact> mapIdContactosId = new Map<String, Contact>();

    	map<String, set<String>> mapContactosSetAccountUps = new Map<String, set<String>>();
		Set<String> setIdAccContactRelCreados = new Set<String>();
		Set<String> setErroresAccContacRel = new Set<String>();		    	

    	map<String, Contact> mapContactosUpsCtaPrinc = new Map<String, Contact>();
    	map<String, AccountContactRelation> mapAccountContactRelationUps = new Map<String, AccountContactRelation>();    	
		Set<String> setErroresAccContacRelErr = new Set<String>();
		Set<String> setIdAccContacRelSucc = new Set<String>();		    	

		Map<String, String> mapIdPerAccIdContacPrinc = new Map<String, String>();

    	map<String, TAM_FechasCargaArchivos__c> mapContactRelFechaCargaUps = new Map<String, TAM_FechasCargaArchivos__c>();    	
		Set<String> setErroresontactRelFechaCargaErr = new Set<String>();
		Set<String> setErroresontactRelFechaCargaSucc = new Set<String>();
		    	
		//Recorre la lista de reg que se estan nsertando
        for(TAM_ClienteServicioPaso__c v: CteServList){
			//Para obtener los datos de los distrubuidores
            if(v.Name != null)
        		sIdVin.add(v.Name);
        }
        System.debug('EN validateRecords sIdVin: '+ sIdVin);
        
        //Consulta todos los colores internos 
        for (Opportunity objOpp : [Select c.Id, c.TAM_Vin__c, c.AccountId, c.Account.IsPersonAccount, 
        		c.Account.PersonContactId From Opportunity c Where TAM_Vin__c IN :sIdVin
        		and c.AccountId != null]){
        	mapOppUps.put(objOpp.TAM_Vin__c, objOpp);
        	System.debug('EN validateRecords mapOppUps: '+ objOpp.AccountId);        	
        }
        System.debug('EN validateRecords mapOppUps: '+ mapOppUps.KeySet());
        System.debug('EN validateRecords mapOppUps: '+ mapOppUps.values());        
                
       	//Inicializa un SavePoint para hacer el rollback en caso de error
       	SavePoint svUpsDatos = Database.setSavepoint();

		//Un try para los errores
        try{

        	//Recorremos los reg de ventas
        	for(TAM_ClienteServicioPaso__c v: CteServList){

                Boolean bPersonaMoral = false;
                String sLlaveCompuestaNombre = '';
    	    	String[] sLlaveNombreCompuesto = new List<String>();

				//****** TODO ESTO PARA LOS DATOS DEL CLIENTE (ACCOUNT) *****///
	        	//Crea la llave foranea apartir de los datos del nombre del cliente
	        	//SI SE TRATA DEL TITULAR
	        	if (v.TAM_TipoCliente__c == 'Primero'){
	        		 
	        		String sApellidoMaterno = v.TAM_LastName2__c != null ? v.TAM_LastName2__c : null;
 					String sLastName = v.TAM_LastName__c;
 					if (sApellidoMaterno != null)
 						sLastName += ' ' + sApellidoMaterno;
 					
 					//Llama la función 	validaNombre para separar el nombre de manera correcta
	    	    	sLlaveNombreCompuesto = validaNombre(v.TAM_FirstName__c, sLastName, 
	    	    		v.TAM_RFC__c); 
	
	                System.debug('EN validateRecords sLlaveNombreCompuesto0: '+ sLlaveNombreCompuesto[0]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto1: '+ sLlaveNombreCompuesto[1]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto2: '+ sLlaveNombreCompuesto[2]);
	                System.debug('EN validateRecords sLlaveNombreCompuesto3: '+ sLlaveNombreCompuesto[3]);
	                
	                //Ve si el arreglo sLlaveNombreCompuesto tiene algo
	                if (sLlaveNombreCompuesto.size() > 2){
	                	//Ve si se trata de una persona Moral
	                	String sNombreCliente = sLlaveNombreCompuesto[0].trim();
	                	if (sNombreCliente == null || sNombreCliente == '')
	                		bPersonaMoral = true;
	                	else
	                		sLlaveCompuestaNombre += sNombreCliente + ' ';
	                	sLlaveCompuestaNombre += sLlaveNombreCompuesto[1] != null && sLlaveNombreCompuesto[1] != '' ? sLlaveNombreCompuesto[1].trim() + ' ' : '';                		 	
	                	sLlaveCompuestaNombre += sLlaveNombreCompuesto[2] != null && sLlaveNombreCompuesto[2] != '' ? sLlaveNombreCompuesto[2].trim() + ' ' : '';                	
	                }//Fin si sLlaveNombreCompuesto.size() >= 2  
					
					//Quita los espacios a los lados
					sLlaveCompuestaNombre = sLlaveCompuestaNombre.trim();
					
					//Ve si ya existe el sLlaveCompuestaNombre en el mapa de mapVinOppIdExtCliente
					mapVinOppIdExtCliente.put(v.Name + ' - ' + sLlaveCompuestaNombre, sLlaveCompuestaNombre);
													
	                System.debug('EN validateRecords sLlaveNombreCompuesto: ' + sLlaveNombreCompuesto);
	                //Para la calle y el codigo postal
	                String sDireccionPaso = v.TAM_Address1__c != null && v.TAM_Address1__c != '' ? v.TAM_Address1__c.trim() : '';
	                String[] lDireccionPaso = sDireccionPaso.contains(';') ? sDireccionPaso.split(';') : new List<String>{sDireccionPaso};  
	                //Para la colonia
	                String sColoniaPaso = v.TAM_Address2__c != null && v.TAM_Address2__c != '' ? v.TAM_Address2__c.trim() : '';
	                //Para la ciudad 
	                String sCiudadPaso = v.TAM_City__c != null && v.TAM_City__c != '' ? v.TAM_City__c.trim() : '';
	                //Para el Estado 
	                String sEstadoPaso = v.TAM_State__c != null && v.TAM_State__c != '' ? v.TAM_State__c.trim() : '';
	                //Para el Código Postal 
	                String sCodigoPostalPaso = v.TAM_Zip__c != null && v.TAM_Zip__c != '' ? v.TAM_Zip__c.trim() : '';
	                //Para el Número de Teléfono 
	                String sPhonePaso = v.TAM_Telhome__c != null && v.TAM_Telhome__c != '' ? v.TAM_Telhome__c.trim() : '';
	                //Para el Número de Teléfono del trabajo 
	                String sPhoneOfficePaso = v.TAM_TelWork__c != null && v.TAM_TelWork__c != '' ? v.TAM_TelWork__c.trim() : '';
	                //Ve si tiene un guión el sPhoneOfficePaso
	                sPhoneOfficePaso = sPhoneOfficePaso.contains('-') ? sPhoneOfficePaso.substring(0,sPhoneOfficePaso.indexOf('-')) : sPhoneOfficePaso;
	                //Para el Número de Teléfono del trabajo 
	                //String sExtOfficePaso = v.TelWorkExt__c != null && v.TelWorkExt__c != '' ? v.TelWorkExt__c.trim() : '';
	                //Para el Correo 
	                String sEmailOfficePaso = v.TAM_Email__c != null && v.TAM_Email__c != '' ? v.TAM_Email__c.trim() : '';
	                //Para el RFC 1 
	                String sRfcPaso = v.TAM_RFC__c != null && v.TAM_RFC__c != '' ? v.TAM_RFC__c.trim() : '';
	                //Para el RFC 2 
	                //String sRfc2Paso = v.TAM_RFC2__c != null && v.TAM_RFC2__c != '' ? v.TAM_RFC2__c.trim() : '';	                
	                //Para el uso de datos personales
	                String sUsoatosPersonales = v.TAM_UsoDatosPersonales__c != null && v.TAM_UsoDatosPersonales__c != '' ? v.TAM_UsoDatosPersonales__c.trim() : '0';
	                //Para el LA FECHA DE CARGA DEL ARCHIVO 
	                String sFechaCargaArchivo = v.TAM_Year__c != null && v.TAM_Month__c != '' && v.TAM_Day__c != null ? v.TAM_Year__c.trim() + '' + v.TAM_Month__c.trim() + '' + v.TAM_Day__c.trim() : '';

					//Ve si el vin esta asociado a una cuenta 
					if (mapOppUps.containsKey(v.Name)){
						//Crea el objeto del tipo Contact
						Contact ContactoPaso = new Contact(										
							//TAM_IdExternoNombre__c = sLlaveCompuestaNombre.toUpperCase() + '-' + mapOppUps.get(v.Name).AccountId,
							TAM_IdExternoNombre__c = sLlaveCompuestaNombre.toUpperCase() + '-' + v.Name,							
							FirstName = sLlaveNombreCompuesto[0].toUpperCase(),
							LastName = sLlaveNombreCompuesto[1] != null ? sLlaveNombreCompuesto[1].toUpperCase() : sLlaveNombreCompuesto[0].toUpperCase(),
							MailingStreet = lDireccionPaso[0].toUpperCase(),
							TAM_Colonia__c = sColoniaPaso.toUpperCase(),
							MailingCity = sCiudadPaso.toUpperCase(), 
							MailingState = sEstadoPaso.toUpperCase(),
							MailingPostalCode = sCodigoPostalPaso,
							Phone = sPhonePaso,
							OtherPhone = sPhoneOfficePaso,						 
							CorreoElectronico__c = sEmailOfficePaso,
							Email = sEmailOfficePaso,
							recordTypeId = VaRtContRegPF,
							LeadSource = 'Servicios',
							TAM_FechaCargaArchivo__c = sFechaCargaArchivo,
							TAM_UsoDatosPersonales__c = sUsoatosPersonales == '1' ? true : false,
							TAM_TipoCliente__c = v.TAM_TipoCliente__c															
		       			);
		                System.debug('EN validateRecords ContactoPaso1: ' + ContactoPaso);
		        		//Crea el reg para la cuenta y metelo al mapa de ContactoPaso
		        		mapContactosUps.put(sLlaveCompuestaNombre.toUpperCase() + '-' + mapOppUps.get(v.Name).AccountId, ContactoPaso);
		        		
		        		//Ve si se trata de una cuenta de tipo personal entonces metela al mapIdPerAccIdContacPrinc
		        		if (mapOppUps.get(v.Name).Account.IsPersonAccount)
		        			mapIdPerAccIdContacPrinc.put(mapOppUps.get(v.Name).AccountId, mapOppUps.get(v.Name).Account.PersonContactId);
					}//Fin si mapOppUps.containsKey(v.Name)
	                                     
					/*Account clientePaso = new Account(
						TAM_IdExternoNombre__c = sLlaveCompuestaNombre,
						ParentId = mapOppUps.containsKey(v.Name) ? mapOppUps.get(v.Name).id : null, 
						BillingStreet = lDireccionPaso[0].toUpperCase(),
						Colonia__c = sColoniaPaso.toUpperCase(),
						BillingCity = sCiudadPaso.toUpperCase(), 
						BillingState = sEstadoPaso.toUpperCase(),
						BillingPostalCode = sCodigoPostalPaso,
						Phone = sPhonePaso,
						Telefono_Oficina__c = sPhoneOfficePaso,
						//Extension_Oficina__c = sExtOfficePaso, 
						Correo_Electronico__c = sEmailOfficePaso,
						RFC__c = sRfcPaso
						//RFC2__c = sRfc2Paso
	       			);
	
	                System.debug('EN validateRecords bPersonaMoral: ' + bPersonaMoral);       			
	       			//Antes de insertarla ve que tipo de cliente y ponle en tipo de reg
	       			if (bPersonaMoral){
	       				clientePaso.recordTypeId = VaRtAccRegPM;
	       				clientePaso.Name = sLlaveNombreCompuesto[1];
	       			}//Fin si bPersonaMoral
	       			if (!bPersonaMoral){       				 
	       				clientePaso.recordTypeId = VaRtAccRegPF;
	       				clientePaso.FirstName = sLlaveNombreCompuesto[0];
	       				clientePaso.LastName = sLlaveNombreCompuesto[1];
	       				clientePaso.Apellido_Paterno__c = sLlaveNombreCompuesto[2];
	       			}//Fin si !bPersonaMoral
	       			
	                System.debug('EN validateRecords clientePaso: ' + clientePaso);
	        		//Crea el reg para la cuenta y metelo al mapa de mapClientesUps
	        		mapClientesUps.put(sLlaveCompuestaNombre, clientePaso);*/
	        		
					//****** HASTA AQUI TODO ESTO PARA LOS DATOS DEL CLIENTE (ACCOUNT) *****///
	        	}//Fin si se trata del titular


				//****** TODO ESTO PARA LOS DATOS DE LOS CONTACTOS (CONTACT) *****///
	        	//Crea la llave foranea apartir de los datos del nombre del cliente
	        	if (v.TAM_TipoCliente__c != 'Primero' || Test.isRunningTest()){	        	
	    	    	String[] sLlaveNombreCompuestoCont = new List<String>();
	    	    	 
	    	    	String sApellidoMaterno = v.TAM_LastName2__c != null ? v.TAM_LastName2__c : null;
 					String sLastName = v.TAM_LastName__c;
 					if (sApellidoMaterno != null)
 						sLastName += ' ' + sApellidoMaterno;
	    	    	
 					//Llama la función 	validaNombre para separar el nombre de manera correcta	    	    	 
	    	    	sLlaveNombreCompuestoCont = validaNombre(v.TAM_FirstName__c, sLastName, v.TAM_RFC__c); 
	
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont00: '+ sLlaveNombreCompuestoCont[0]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont11: '+ sLlaveNombreCompuestoCont[1]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont22: '+ sLlaveNombreCompuestoCont[2]);
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont33: '+ sLlaveNombreCompuestoCont[3]);
	                Boolean bTieneNombreContacto = false;
	                String sLlaveCompuestaNombreCont = '';
	
	                //Ve si el arreglo sLlaveNombreCompuesto tiene algo
	                if (sLlaveNombreCompuestoCont.size() > 2){
	                	//Ve si se trata de una persona Moral
	                	String sNombreCliente = sLlaveNombreCompuestoCont[0].trim();
	                	if (sNombreCliente == null || sNombreCliente == '')
	                		bTieneNombreContacto = true;
	               		sLlaveCompuestaNombreCont += sNombreCliente + ' ';
	                	sLlaveCompuestaNombreCont += sLlaveNombreCompuestoCont[1] != null && sLlaveNombreCompuestoCont[1] != '' ? sLlaveNombreCompuestoCont[1].trim() + ' ' : '';                		 	
	                	sLlaveCompuestaNombreCont += sLlaveNombreCompuestoCont[2] != null && sLlaveNombreCompuestoCont[2] != '' ? sLlaveNombreCompuestoCont[2].trim() + ' ' : '';                	
	                }//Fin si sLlaveNombreCompuesto.size() >= 2  
	
					//Quita los espacios a los lados
					sLlaveCompuestaNombreCont = sLlaveCompuestaNombreCont.trim();
					
					//Ve si ya existe el sLlaveCompuestaNombre en el mapa de mapVinOppIdExtCliente
					mapVinOppIdExtClienteContacto.put(sLlaveCompuestaNombreCont, sLlaveCompuestaNombre);
					//Set<String> setErroresAccContactUps = new Set<String>();
	
					//Ve si ya existe el sLlaveCompuestaNombre en el mapa de mapVinOppIdExtCliente
					mapVinOppIdExtCliente.put(v.Name + ' - ' + sLlaveCompuestaNombreCont, sLlaveCompuestaNombreCont);
														
	                System.debug('EN validateRecords sLlaveNombreCompuestoCont: ' + sLlaveNombreCompuestoCont);
	                //Para la calle y el codigo postal
	                String sDireccionPaso = v.TAM_Address1__c != null && v.TAM_Address1__c != '' ? v.TAM_Address1__c.trim() : '';
	                String[] lDireccionPaso = sDireccionPaso.contains(';') ? sDireccionPaso.split(';') : new List<String>{sDireccionPaso};  
	                //Para la colonia
	                String sColoniaPaso = v.TAM_Address2__c != null && v.TAM_Address2__c != '' ? v.TAM_Address2__c.trim() : '';
	                //Para la ciudad 
	                String sCiudadPaso = v.TAM_City__c != null && v.TAM_City__c != '' ? v.TAM_City__c.trim() : '';
	                //Para el Estado 
	                String sEstadoPaso = v.TAM_State__c != null && v.TAM_State__c != '' ? v.TAM_State__c.trim() : '';
	                //Para el Código Postal 
	                String sCodigoPostalPaso = v.TAM_Zip__c != null && v.TAM_Zip__c != '' ? v.TAM_Zip__c.trim() : '';
	                //Para el Número de Teléfono 
	                String sPhonePaso = v.TAM_Telhome__c != null && v.TAM_Telhome__c != '' ? v.TAM_Telhome__c.trim() : '';
	                //Para el Número de Teléfono del trabajo 
	                String sPhoneOfficePaso = v.TAM_TelWork__c != null && v.TAM_TelWork__c != '' ? v.TAM_TelWork__c.trim() : '';
	                //Para el Número de Teléfono del trabajo 
	                //String sExtOfficePaso = v.TelWorkExt__c != null && v.TelWorkExt__c != '' ? v.TelWorkExt__c.trim() : '';
	                //Para el Correo 
	                String sEmailOfficePaso = v.TAM_Email__c != null && v.TAM_Email__c != '' ? v.TAM_Email__c.trim() : '';
	                //Para el RFC 1 
	                String sRfcPaso = v.TAM_RFC__c != null && v.TAM_RFC__c != '' ? v.TAM_RFC__c.trim() : '';
	                //Para el RFC 2 
	                //String sRfc2Paso = v.TAM_RFC2__c != null && v.TAM_RFC2__c != '' ? v.TAM_RFC2__c.trim() : '';
	                //Para el uso de datos personales
	                String sUsoatosPersonales = v.TAM_UsoDatosPersonales__c != null && v.TAM_UsoDatosPersonales__c != '' ? v.TAM_UsoDatosPersonales__c.trim() : '0';	                
	                //Para el LA FECHA DE CARGA DEL ARCHIVO 
	                String sFechaCargaArchivo = v.TAM_Year__c != null && v.TAM_Month__c != '' && v.TAM_Day__c != null ? v.TAM_Year__c.trim() + '' + v.TAM_Month__c.trim() + '' + v.TAM_Day__c.trim() : '';
	                
					//Ve si el vin esta asociado a una cuenta 
					if (mapOppUps.containsKey(v.Name)){
						//Crea el objeto del tipo Contact
						Contact ContactoPaso = new Contact(						
							//TAM_IdExternoNombre__c = sLlaveCompuestaNombreCont.toUpperCase() + '-' + mapOppUps.get(v.Name).AccountId,
							TAM_IdExternoNombre__c = sLlaveCompuestaNombreCont.toUpperCase() + '-' + v.Name,							
							FirstName = sLlaveNombreCompuestoCont[0].toUpperCase(),
							LastName = sLlaveNombreCompuestoCont[1] != null ? sLlaveNombreCompuestoCont[1].toUpperCase() : sLlaveNombreCompuestoCont[0].toUpperCase(),
							MailingStreet = lDireccionPaso[0].toUpperCase(),
							TAM_Colonia__c = sColoniaPaso.toUpperCase(),
							MailingCity = sCiudadPaso.toUpperCase(), 
							MailingState = sEstadoPaso.toUpperCase(),
							MailingPostalCode = sCodigoPostalPaso,
							Phone = sPhonePaso,
							OtherPhone = sPhoneOfficePaso,						 
							CorreoElectronico__c = sEmailOfficePaso,
							Email = sEmailOfficePaso,
							recordTypeId = VaRtContRegPF,
							LeadSource = 'Servicios',
							TAM_FechaCargaArchivo__c = sFechaCargaArchivo,
							TAM_UsoDatosPersonales__c = sUsoatosPersonales == '1' ? true : false							
		       			);
	                	System.debug('EN validateRecords ContactoPaso2: ' + ContactoPaso + ' Opp: ' + mapOppUps.get(v.Name));
	        			//Crea el reg para la cuenta y metelo al mapa de ContactoPaso
	        			mapContactosUps.put(sLlaveCompuestaNombreCont.toUpperCase() + '-' + mapOppUps.get(v.Name).AccountId, ContactoPaso);
	        			
		        		//Ve si se trata de una cuenta de tipo personal entonces metela al mapIdPerAccIdContacPrinc
		        		if (mapOppUps.get(v.Name).Account.IsPersonAccount)
		        			mapIdPerAccIdContacPrinc.put(mapOppUps.get(v.Name).AccountId, mapOppUps.get(v.Name).Account.PersonContactId);
					}//Fin si mapOppUps.containsKey(v.Name)

	        	}//Segundo propietario que es un contacto asociado a la cuenta
				//****** HASTA AQUI PARA LOS DATOS DE LOS CONTACTOS (CONTACT) *****///

        	}//Fin del for para ventasList
           	System.debug('EN validateRecords mapContactosUps: ' + mapContactosUps.KeySet());
           	System.debug('EN validateRecords mapContactosUps: ' + mapContactosUps.Values());


           	System.debug('EN validateRecords mapContactosUps1: ' + mapContactosUps.keySet() + ' ' + mapContactosUps.values());
        	//Ya tiens los datos de las cuentas has el upsert con los datos de mapContactosUps 
        	Integer icntUpsCtes = 0;
        	if (!mapContactosUps.isEmpty()){
        		List<Contact> lContactos = mapContactosUps.values(); 
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
        		for (Contact Contacto : lContactos){
        			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;
        			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;
        			String sIdVinPaso = sIdExtPaso.contains('-') ? sIdExtPaso.substring(sIdExtPaso.IndexOf('-')+1, sIdExtPaso.length()) : null;
		           	System.debug('EN validateRecords sNombreContact: ' + sNombreContact + ' sIdVinPaso: ' + sIdVinPaso);        			
        			//Ya tienes el VIN Asociado al contacto, busca la cuenta en el mapa de mapVinOppIdUps
        			String sIdAccount;
        			if (sIdVinPaso != null)
						sIdAccount = mapOppUps.containsKey(sIdVinPaso) ? mapOppUps.get(sIdVinPaso).AccountId : null;
		           	System.debug('EN validateRecords sIdAccount: ' + sIdAccount + ' sIdAccount: ' + sIdAccount);						
					//Ahora si actualiza el campo de TAM_IdExternoNombre__c con el ID de la cuenta
					if ( (sNombreContact != null && sIdAccount != null) || Test.isRunningTest() ){	
						//Clona el contacto 
						Contact contactoPrincipal = Contacto.clone();
						contactoPrincipal.TAM_IdExternoNombre__c =  sNombreContact + '-' + Label.TAM_IdCuentaPrincipalContactosCRM;
						contactoPrincipal.AccountId = Label.TAM_IdCuentaPrincipalContactosCRM;
						//Metelo al mapa de mapContactosUpsCtaPrinc
						mapContactosUpsCtaPrinc.put(contactoPrincipal.TAM_IdExternoNombre__c, contactoPrincipal);
					}//Fin si sNombreContact != null && sIdAccount != null
		           	//Ve que tiene el mapa de mapContactosUpsCtaPrinc
        		}//Fin del for para la lista de lContactos
	           	System.debug('EN validateRecords mapContactosUpsCtaPrinc: ' + mapContactosUpsCtaPrinc.keySet() + ' ' + mapContactosUpsCtaPrinc.values());        		
        		//Ve si tiene algo el mapa de mapContactosUpsCtaPrinc
				if (!mapContactosUpsCtaPrinc.isEmpty()){
	        		List<Contact> lContactosCtaPrinc = mapContactosUpsCtaPrinc.values();
	        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
					List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lContactosCtaPrinc, Contact.TAM_IdExternoNombre__c, false);
					//Ve si hubo error
					for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
						if (!objDtbUpsRes.isSuccess()){
							setErroresContactosUps.add('En el contacto : ' + lContactosCtaPrinc.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
           					System.debug('En el contacto : ' + lContactosCtaPrinc.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());							
						}
						if (objDtbUpsRes.isSuccess()){
							setIdContactCreados.add(objDtbUpsRes.getId());
           					System.debug('EN validateRecords objDtbUpsRes.getId() Contacts: ' + objDtbUpsRes.getId());							
						}
						icntUpsCtes++;	
					}//Fin del for para lDtbUpsRes				
				}//Fin si !mapContactosUpsCtaPrinc.isEmpty()        						
        	}//Fin si mapContactosUps.isEmpty()
           	System.debug('EN validateRecords setErroresContactosUps0: ' + setErroresContactosUps);        	
           	System.debug('EN validateRecords setIdContactCreados0: ' + setIdContactCreados);			        	
			//Consulta los clientes que se acaban de crear en setIdCtesCreados y metelos a mapIdClientesId
			for (Contact Contacto : [Select id, TAM_IdExternoNombre__c, TAM_FechaCargaArchivo__c
				From Contact Where id IN: setIdContactCreados]){
       			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;				
	   			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;				
				mapIdContactosId.put(sNombreContact, Contacto);				
			}			
           	System.debug('EN validateRecords mapIdContactosId: ' + mapIdContactosId.keySet() + ' ' + mapIdContactosId.values());			
           	System.debug('EN validateRecords mapContactosUps: ' + mapContactosUps.keySet() + ' ' + mapContactosUps.values());
           	
			//Recoerre la lista de contactos que se acaban de crear y crea la relación con la cuenta principal
			//De Contactos CRM Cuenta Principal (0013F00000MzeaOQAR)
			Set<String> setTAMIdExternoACR = new Set<String>();
			for (String sIdExtrnoPaso : mapIdContactosId.keySet()){				
	           	System.debug('EN validateRecords sIdExtrnoPaso3: ' + sIdExtrnoPaso);				
				if (sIdExtrnoPaso != null){ 
					//recorre la lista de contactos de mapContactosUps.values()
	        		List<Contact> lContactos = mapContactosUps.values();					
	        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
	        		for (Contact Contacto : lContactos){
	        			Boolean bExiste = false;
	        			String sIdExtPaso = Contacto.TAM_IdExternoNombre__c;
	        			String sNombreContact = sIdExtPaso.contains('-') ? sIdExtPaso.substring(0,sIdExtPaso.IndexOf('-')) : null;
	        			String sIdVinPaso = sIdExtPaso.contains('-') ? sIdExtPaso.substring(sIdExtPaso.IndexOf('-')+1, sIdExtPaso.length()) : null;
			           	System.debug('EN validateRecords sNombreContact3: ' + sNombreContact + ' sIdVinPaso: ' + sIdVinPaso);        			
	        			//Ya tienes el VIN Asociado al contacto, busca la cuenta en el mapa de mapOppUps
	        			String sIdAccount;
	        			if (sIdVinPaso != null)
							sIdAccount = mapOppUps.containsKey(sIdVinPaso) ? mapOppUps.get(sIdVinPaso).AccountId : null;
						//Ahora si actualiza el campo de TAM_IdExternoNombre__c con el ID de la cuenta
						if ( (sNombreContact != null && sIdAccount != null) || Test.isRunningTest()){ 							
							String TAM_IdExterno = sIdExtrnoPaso + '-' + sIdAccount; 
			           		System.debug('EN validateRecords sIdAccount3: ' + sIdAccount + ' TAM_IdExterno: ' + TAM_IdExterno);
			           		System.debug('EN validateRecords sIdExtrnoPaso3: ' + sIdExtrnoPaso + ' sNombreContact: ' + sNombreContact);			           		
							//Ve si TAM_IdExterno es igual a sIdExtrnoPaso
							if (sNombreContact == sIdExtrnoPaso){
								//Busca el nombre en el mapa de mapIdContactosId
								if (mapIdContactosId.containsKey(sNombreContact)){
									//Crea el objeto del tipo AccountContactRelation
		           					AccountContactRelation AccountContactRelationPaso = new AccountContactRelation(
				       					TAM_IdExterno__c = TAM_IdExterno,
				       					ContactId = mapIdContactosId.get(sNombreContact).id,
				       					AccountId = sIdAccount,
				       					TAM_VIN__c = sIdVinPaso 
				       				);
		           					System.debug('EN validateRecords TAM_IdExterno: ' + TAM_IdExterno + ' AccountContactRelationPaso: ' + AccountContactRelationPaso);			       				
				       				//Agregala al mapa de mapAccountContactRelationUps
				       				mapAccountContactRelationUps.put(TAM_IdExterno, AccountContactRelationPaso);
				       				//Agrega el id externo al set de setTAMIdExternoACR
				       				setTAMIdExternoACR.add(TAM_IdExterno);
				       				bExiste = true;
				       				
				       				String sLlaveIdExterna = sIdVinPaso + '-' + mapIdContactosId.get(sNombreContact).id + '-' +  mapIdContactosId.get(sNombreContact).TAM_FechaCargaArchivo__c;
				       				//Crea el reg en el objeto de 
				       				mapContactRelFechaCargaUps.put(sLlaveIdExterna, new TAM_FechasCargaArchivos__c(
											Name = sLlaveIdExterna,
											TAM_IdExterno__c = sLlaveIdExterna,
											TAM_Fecha__c = mapIdContactosId.get(sNombreContact).TAM_FechaCargaArchivo__c
				       					)
				       				);
				       				
								}//Fin si mapIdContactosId.containsKey(sNombreContact)
							}//Fin si TAM_IdExterno == sIdExtrnoPaso
						}//Fin si sNombreContact != null && sIdAccount != null
						//Ya lo encontramos entonces salte
						if (bExiste)
							break;
					}//Fin del for para la lContactos
       				
				}//Fin si sIdExterno != null
			}//Fin del for para la lista de mapIdContactosId.keySet()
           	System.debug('EN validateRecords mapContactRelFechaCargaUps: ' + mapContactRelFechaCargaUps.keySet());
           	System.debug('EN validateRecords mapContactRelFechaCargaUps: ' + mapContactRelFechaCargaUps.values());

        	icntUpsCtes = 0;			
			//Ve si tiene algo el mapa de  mapContactRelFechaCargaUps
			if (!mapContactRelFechaCargaUps.isEmpty()){
        		List<TAM_FechasCargaArchivos__c> lContFechaCrea = mapContactRelFechaCargaUps.values();
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lContFechaCrea, TAM_FechasCargaArchivos__c.TAM_IdExterno__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess()){
						setErroresontactRelFechaCargaErr.add('En TAM_FechasCargaArchivos__c : ' + lContFechaCrea.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
       					System.debug('En AccountContactRelation : ' + lContFechaCrea.get(icntUpsCtes).Name + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());						
					}
					if (objDtbUpsRes.isSuccess()){
						setErroresontactRelFechaCargaSucc.add(objDtbUpsRes.getId());
       					System.debug('EN validateRecords objDtbUpsRes.getId() TAM_FechasCargaArchivos__c: ' + objDtbUpsRes.getId());
					}					
					icntUpsCtes++;	
				}//Fin del for para lDtbUpsRes				
			}//Fin si !mapContactRelFechaCargaUps.isEmpty()
           	System.debug('EN validateRecords setErroresontactRelFechaCargaErr: ' + setErroresontactRelFechaCargaErr);        	
           	System.debug('EN validateRecords setErroresontactRelFechaCargaSucc: ' + setErroresontactRelFechaCargaSucc);	
			
           	System.debug('EN validateRecords mapAccountContactRelationUps: ' + mapAccountContactRelationUps.keySet());
           	System.debug('EN validateRecords mapAccountContactRelationUps: ' + mapAccountContactRelationUps.values());
			Set<String> setExisteACRRel = new Set<String>();
			Map<String, AccountContactRelation> mapAccountContactRelationUpsFinal = new Map<String, AccountContactRelation>();  
			//Ve si tiene algo el mapa de 
			if (!mapAccountContactRelationUps.isEmpty()){
				//Consulta todos los reg de AccountContactRelation donde el TAM_IdExterno__c este en setTAMIdExternoACR
				for (AccountContactRelation AccContRelPaso : [select id, TAM_IdExterno__c from AccountContactRelation
					where TAM_IdExterno__c IN : setTAMIdExternoACR]){
					setExisteACRRel.add(AccContRelPaso.TAM_IdExterno__c);
				}
				//Muy bien ya tienes los datos de las relaciones que existen en el set de setExisteACRRel
				//Recorre el mapa de mapAccountContactRelationUps y toma los reg que no esten en setExisteACRRel
				for (AccountContactRelation AccContRelPaso : mapAccountContactRelationUps.values()){
					//Ve si no existe AccContRelPaso.TAM_IdExterno__c  en setExisteACRRel agregalo a la lista de
					if (!setExisteACRRel.contains(AccContRelPaso.TAM_IdExterno__c))
						mapAccountContactRelationUpsFinal.put(AccContRelPaso.TAM_IdExterno__c, AccContRelPaso);
				}//Fin del for para mapAccountContactRelationUps.values()
			}//Fin si !mapAccountContactRelationUps.isEmpty()
           	System.debug('EN validateRecords mapAccountContactRelationUpsFinal: ' + mapAccountContactRelationUpsFinal.keySet());
           	System.debug('EN validateRecords mapAccountContactRelationUpsFinal: ' + mapAccountContactRelationUpsFinal.values());
		
        	icntUpsCtes = 0;			
			//Ve si tiene algo el mapa de  mapAccountContactRelationUpsFinal
			if (!mapAccountContactRelationUpsFinal.isEmpty()){
        		List<AccountContactRelation> lAccContacRel = mapAccountContactRelationUpsFinal.values();
        		//Recorre la lista de Opp y busca el VIN para asociar el id de la cuenta en AccountId
				List<Database.Upsertresult> lDtbUpsRes = Database.upsert(lAccContacRel, AccountContactRelation.TAM_IdExterno__c, false);
				//Ve si hubo error
				for (Database.Upsertresult objDtbUpsRes : lDtbUpsRes){
					if (!objDtbUpsRes.isSuccess()){
						setErroresAccContacRelErr.add('En AccountContactRelation : ' + lAccContacRel.get(icntUpsCtes).TAM_VIN__c + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());
       					System.debug('En AccountContactRelation : ' + lAccContacRel.get(icntUpsCtes).TAM_VIN__c + ' hubo error a la hora de crear/Actualizar: ' + objDtbUpsRes.getErrors()[0].getMessage());						
					}
					if (objDtbUpsRes.isSuccess()){
						setIdAccContacRelSucc.add(objDtbUpsRes.getId());
       					System.debug('EN validateRecords objDtbUpsRes.getId() AccountContactRelation: ' + objDtbUpsRes.getId());
					}					
					icntUpsCtes++;	
				}//Fin del for para lDtbUpsRes				
			}//Fin si !mapAccountContactRelationUpsFinal.isEmpty()
           	System.debug('EN validateRecords setErroresAccContacRelErr: ' + setErroresAccContacRelErr);        	
           	System.debug('EN validateRecords setIdAccContacRelSucc: ' + setIdAccContacRelSucc);	
		           	           	
        } catch(Exception ex){
            System.debug('Error en validateRecords: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }
        
		//Un rollback para todo solo estamos en pruebas
		//Database.rollback(svUpsDatos);
	
	}
	
	//Un meotodo que regresa el nombre separado
    private String[] validaNombre(String FirstName, String LastName, String RFC){
    	System.debug('Entro a validaNombre FirstName: ' + FirstName + ' LastName: ' + LastName + ' RFC: ' + RFC);    	 
    	String[] sNombreValido = new String[5];
    	
        try{
         	
	    	Integer iCnt = 0;
	    	Set<String> setAcentos = new Set<String>{'Á','É','Í','Ó','Ú'};
	    	List<String> lSinAcento = new List<String>{'A','E','I','O','U'};    	
	    	String sFirstName = FirstName != null ? FirstName.trim().toUpperCase() : '';
	    	String sLastName = LastName != null ? LastName.trim().toUpperCase() : '';
	    	String sRFC = RFC != null ? RFC.trim().toUpperCase() : '';
	    	//String sRFC2 = RFC2 != null ? RFC2.trim().toUpperCase() : '';
	    	//String sIdExterno = IdExterno!= null ? IdExterno.trim().toUpperCase() : '';
	
			//Remplaza todos los acentos de las palabras
			for (String sAcento : setAcentos){
				sFirstName = sFirstName.replaceAll(sAcento, lSinAcento.get(iCnt));
				sLastName = sLastName.replaceAll(sAcento, lSinAcento.get(iCnt));
				iCnt++;
			}
			
			//Ya tienes los datos en mayuscular y sin espacios ni acentos, destripa el nombre
			String[] lFirstName = (sFirstName != null && sFirstName != '') ? (sFirstName.contains(';') ? sFirstName.split(';') : new List<String>{sFirstName}) : new List<String>();
			String[] lLastName;
			//Si tiene datos del nombre
			if (sFirstName != null && sFirstName != ''){
				//Quita los eapacioa en blanco y solo deja uno entre el nombre
				String sQuitaEspaciosDos = (sLastName != null && sLastName != '') ? sLastName.replaceAll('  ', ' ') : '';//Dos espacios
				String sQuitaEspaciosTres = (sQuitaEspaciosDos != null && sQuitaEspaciosDos != '') ? sQuitaEspaciosDos.replaceAll('  ', ' ') : '';//Dos espacios
				//Ve cuando espacios en blanco tiene el apellido, si tiene mas de 1 entonces es una empresa				
				String[] lLastNamePaso = (sQuitaEspaciosTres != null && sQuitaEspaciosTres != '') ? (sQuitaEspaciosTres.contains(' ') ? sQuitaEspaciosTres.split(' ') : new List<String>{sQuitaEspaciosTres}) : new List<String>();
		    	System.debug('Entro a validaNombre lLastNamePaso: ' + lLastNamePaso.size());
		    	//Ve si tiene mas de lLastNamePaso 
				if (lLastNamePaso.size() > 2){
					lLastName = (sLastName != null && sLastName != '') ? (sLastName.contains(';') ? sLastName.split(';') : new List<String>{sLastName}) : new List<String>();
					lFirstName = new List<String>();					
				}//Fin si lLastNamePaso.size() > 2
		    	//Ve si tiene mas de lLastNamePaso				
				if (lLastNamePaso.size() <= 2)
					lLastName = lLastNamePaso;
			}//Fin si sFirstName != null && sFirstName != ''
			
			//No tiene datos del nombre			
			if (sFirstName == null || sFirstName == ''){				
				//Quita los espacios en blanco cuando son las de dos
				String sQuitaEspaciosDos = (sLastName != null && sLastName != '') ? sLastName.replaceAll('  ', ' ') : '';//Dos espacios
				String sQuitaEspaciosTres = (sQuitaEspaciosDos != null && sQuitaEspaciosDos != '') ? sQuitaEspaciosDos.replaceAll('  ', ' ') : '';//Dos espacios				
				lLastName = (sQuitaEspaciosTres != null && sQuitaEspaciosTres != '') ? (sQuitaEspaciosTres.contains(';') ? sQuitaEspaciosTres.split(';') : new List<String>{sQuitaEspaciosTres}) : new List<String>();
			}//Fin si sFirstName == null || sFirstName == ''
			
			//Ve si los dos campos son exactamente iguales
			if (FirstName != null && LastName != null){
				if (LastName.contains(FirstName)){
		    		System.debug('Entro a validaNombre LastName VAL0: ' + LastName);					
					//Ve si tienen mas de un espacio en blanco
					String[] lFirstNamePaso = FirstName.contains(' ') ? FirstName.split(' ') : new List<String>{FirstName};				
					String[] lLastNamePaso = LastName.contains(' ') ? LastName.split(' ') : new List<String>{FirstName};
	    			System.debug('Entro a validaNombre lFirstNamePaso0: ' + lFirstNamePaso + ' lLastNamePaso0: ' + lLastNamePaso);				
					//Ve si tienen mas de un espacio los nombres
					if (lFirstNamePaso.size() > 1 && lLastNamePaso.size() > 1){
						lFirstName = new List<String>{''};											
						lLastName = new List<String>{FirstName};
		    			System.debug('Entro a validaNombre lLastName000: ' + lLastName);
					}//Fin si lFirstNamePaso.size() > 1 && lLastNamePaso.size() > 1
				}
			}//Fin si FirstName == LastName && FirstName != null && LastName != null
			
	    	System.debug('Entro a validaNombre lFirstName1: ' + lFirstName);
	    	System.debug('Entro a validaNombre lLastName1: ' + lLastName);
	    		    		
	    	String sNombreConcatenado = '';
	    	iCnt = 1;		
			//Concatena los nombres
			for (String sNombre : lFirstName){
				if (sNombre != null && sNombre != '')
					sNombreConcatenado += sNombre + ' ';
			}
			//Agrega el nombre a sNombreValido[0] 
			sNombreValido[0] = sNombreConcatenado;
	    	System.debug('Entro a validaNombre sNombreConcatenado: ' + sNombreConcatenado);
	    				
			//Concatena los apellidos
			for (String sApellido : lLastName){
				if (sApellido != null && sApellido != ''){
					sNombreConcatenado = sApellido + ' ';
					sNombreValido[iCnt] = sNombreConcatenado;
					iCnt++;
				} //Fin si sApellido != null && sApellido != ''
			}
	    	
	    	System.debug('Entro a validaNombre sNombreValido: ' + sNombreValido);

        }catch(Exception ex){
            System.debug('Error en validaNombre detalle: ' + ex.getMessage() + ' Linea: ' + ex.getLineNumber());
        }
		
		//Regresa el nombre como llave    	    	
    	return sNombreValido;
    }


	
}